{Copyright (C) 1991 by J. Scott Sanbar.  All Rights Reserved}

{Needs sister .ASM module NONSTOP.ASM                       }

unit NonStop;                         {Makes your program UNSTOPPABLE!}

interface

const
   NoBoot  : boolean = true;              {flag to disable soft boot  }
   NoBreak : boolean = true;              {flag to disable Ctrl-Break }
   NoCtrlC : boolean = true;              {flag to disable Ctrl-C     }
   NoCtrl2 : boolean = true;              {flag to disable Ctrl-2     }
   NoAlt3  : boolean = true;              {flag to disable Alt-3 (Pad)}

 procedure InstallNonStopISR;
 procedure NonStopExitProc;

implementation

 var
   PreNonStopExitProc : pointer;

 const
   Installed : boolean = false;

 procedure InstallVector; External; {$L NonStop} {Link in NONSTOP.OBJ}
 procedure RemoveVector; External;
 procedure NonStopISR; External;

 procedure InstallNonStopISR;

 begin
  if not Installed then
  begin
   InstallVector;                     {Point Intr 9 to my ISR, save old }
   PreNonStopExitProc := ExitProc;    {Save old ExitProc                }
   ExitProc := @NonStopExitProc;      {Link in NonStopExitProc          }
   Installed := true;
  end;
 end;

 procedure NonStopExitProc;

 begin
  ExitProc := PreNonStopExitProc;      {Point ExitProc to next  }
  RemoveVector;                        {Return old Int 9 Vector }
 end;

end.